/*
 * @Author: Dimitrios Katsaros
 * @Date:   2018-01-12
 */

/* Set of commkonly used operations for array access
 */
#ifndef __QTEC_LIB_ARRAY_GET_SET_H__
#define __QTEC_LIB_ARRAY_GET_SET_H__

#include <qtec/core/array.h>

gboolean qtec_array_set_2d_dims(QtecArray *array, guint width, guint height);
gboolean qtec_array_set_3d_dims(QtecArray *array, guint width, guint height,
				guint depth);
void *qtec_array_get_2d_element_pointer(QtecArray *array, guint x, guint y);
void *qtec_array_get_3d_element_pointer(QtecArray *array, guint x, guint y,
					guint z);

gboolean qtec_array_get_uint(QtecArray *array, guint pos, gint64 *val);
gboolean qtec_array_get_int(QtecArray *array, guint pos, gint64 *val);
gboolean qtec_array_set_uint(QtecArray *array, guint pos, gint64 val);
gboolean qtec_array_set_int(QtecArray *array, guint pos, gint64 val);
gboolean qtec_array_get_nd_uint(QtecArray *array, guint arrlen,
				guint posarray[], gint64 *val);
gboolean qtec_array_get_nd_int(QtecArray *array, guint arrlen, guint posarray[],
			       gint64 *val);
gboolean qtec_array_set_nd_uint(QtecArray *array, guint arrlen,
				guint posarray[], gint64 val);
gboolean qtec_array_set_nd_int(QtecArray *array, guint arrlen, guint posarray[],
			       gint64 val);
#endif
