/*
 * @Author: Dimitrios Katsaros
 * @Date:   2017-12-06
 */

#ifndef __QTEC_LIB_ARRAY_MATH_H__
#define __QTEC_LIB_ARRAY_MATH_H__

#include <qtec/core/array.h>

G_BEGIN_DECLS

/* Takes a 2d/3d array as input and normalizes it. The normalization is channel
 * based, so if you wish to i.e. produce a normalization across all channels
 * you should take this result and run a per channel normalization.
 */
gboolean qtec_array_math_normalize(QtecArray *inp, gint64 lowlim, gint64 hilim,
				   gboolean signed_val);

/* Same as qtec_array_math_normalize, but it also takes care of
 * setting the necessary elem_size of the result
 * So that it can better handle 8<->16bit conversions
 */
gboolean qtec_array_math_normalize_transform(QtecArray *inp, QtecArray **out,
					     gint64 lowlim, gint64 hilim,
					     gboolean signed_val);

G_END_DECLS
#endif
