/*
 * @Author: Dimitrios Katsaros
 * @Date:   2018-05-28
 */

#ifndef __QTEC_LIB_CAIRO_CORE_H__
#define __QTEC_LIB_CAIRO_CORE_H__

#include <qtec/core/array.h>
#include <qtec/io/pam.h>
#include <cairo.h>

G_BEGIN_DECLS

typedef struct _QtecCairoXRGB QtecCairoXRGB;
typedef struct _QtecCairoRGB565 QtecCairoRGB565;
typedef struct _QtecCairoImage QtecCairoImage;

QtecCairoImage *qtec_cairo_new_image(cairo_format_t format, guint width,
				     guint height);
void qtec_cairo_free_image(QtecCairoImage *img);

QtecArray *qtec_cairo_get_array_ref(QtecCairoImage *img);
cairo_format_t qtec_cairo_get_format(QtecCairoImage *img);

//remember to call: cairo_destroy(context); when done with the context
cairo_t *qtec_cairo_new_context(QtecCairoImage *img);

gboolean qtec_cairo_xrgb_to_ppm(QtecCairoImage *cairo_img, QtecIOPam **pam);
gboolean qtec_cairo_ppm_to_xrgb(QtecIOPam *pam, QtecCairoImage **cairo_img);

QtecCairoImage *qtec_cairo_new_image_from_array(QtecArray *arr,
						cairo_format_t format);

G_END_DECLS

#endif
