/*
 * @Author: Marianna S. Buschle
 * @Date:   2018-06-22
 */

#ifndef __QTEC_LIB_CAIRO_DRAW_H__
#define __QTEC_LIB_CAIRO_DRAW_H__

#include <qtec/cairo/core.h>
#include <qtec/geometry/geometry.h>

G_BEGIN_DECLS

typedef enum {
	QTEC_CAIRO_ARROW_OPEN,
	QTEC_CAIRO_ARROW_SOLID,
	QTEC_CAIRO_ARROW_CIRCLE
} QtecCairoArrowStyle;

void qtec_cairo_set_line_width_px(cairo_t *context, int thickness_px);
gdouble qtec_cairo_get_line_width_px(cairo_t *context);

void qtec_cairo_paint_px(cairo_t *context, QtecGeometryPoint2d p);

void qtec_cairo_draw_arrow(cairo_t *context, QtecGeometryPoint2d start,
			   QtecGeometryPoint2d end, QtecCairoArrowStyle type);
void qtec_cairo_draw_line(cairo_t *context, QtecGeometryPoint2d p0,
			  QtecGeometryPoint2d p1);
gboolean qtec_cairo_draw_quadrilateral(cairo_t *context,
				       QtecGeometryQuad2d quad, gboolean solid);

G_END_DECLS

#endif
