/*
 * @Author: Dimitrios Katsaros
 * @Date:   2017-11-16
 */

#ifndef __QTEC_LIB_CORE_NET_H__
#define __QTEC_LIB_CORE_NET_H__

#include <glib.h>

G_BEGIN_DECLS
typedef struct _QtecNetData QtecNetData;

QtecNetData *qtec_net_new_data();
void qtec_net_free_data(QtecNetData *ifdata);
/* The list points to static memory so you should not manipulate it
 * and you only need to free the list its self
 */
GList *qtec_net_list_interface_names(QtecNetData *ifdata);
gboolean qtec_net_get_ip4_address(QtecNetData *ifdata, const gchar *ifname,
				  const gchar **addrstr);
gboolean qtec_net_get_ip6_address(QtecNetData *ifdata, const gchar *ifname,
				  const gchar **addrstr);
gboolean qtec_net_get_mac_address(QtecNetData *ifdata, const gchar *ifname,
				  const gchar **addrstr);
void qtec_net_use_g_errors(struct _QtecNetData *ifdata, gboolean active);
GError *qtec_net_get_last_g_error(struct _QtecNetData *ifdata);

G_END_DECLS
#endif
