/*
* @Author: Dimitrios Katsaros
* @Date:   2017-10-18 11:23:26
*/

/*
 * Qtec specific GValue types
 */

#ifndef __QTEC_LIB_CORE_QTEC_VALUE_H__
#define __QTEC_LIB_CORE_QTEC_VALUE_H__

#include <glib-object.h>
#include <qtec/core/array.h>

G_BEGIN_DECLS

#define QTEC_TYPE_ARRAY (qtec_array_get_type())
GType qtec_array_get_type(void);

#define QTEC_TYPE_MEMORY_CHUNK (qtec_mem_chunk_get_type())
GType qtec_mem_chunk_get_type(void);

/* qtec_array */
/* Returns the contained array. The lifetime is connected to the
 * GValue, so if the user wants to keep it they need to reference.
 */
const QtecArray *qtec_value_get_qtec_array(const GValue *val);

/* Gets the contained array. The returned array is referenced and should
 * be unreffed after use
 */
QtecArray *qtec_value_dup_qtec_array(const GValue *val);
void qtec_value_set_qtec_array(GValue *val, const QtecArray *arr);

/* memory chunks */
void qtec_value_set_mem_chunk(GValue *val, gsize size, gpointer ptr);
gsize qtec_value_get_mem_chunk_size(const GValue *val);
gpointer qtec_value_get_mem_chunk_ptr(const GValue *val);

G_END_DECLS
#endif
