/*
* @Author: Dimitrios Katsaros
* @Date:   2017-05-04 11:43:45
*/

/*
 * Version information for qteclib, as is on compile time
 */

#ifndef __QTEC_LIB_CORE_VERSION_H__
#define __QTEC_LIB_CORE_VERSION_H__

#include <glib.h>

G_BEGIN_DECLS

//stringify defines for #pragma message
#define STR(s) XSTRINGIFY(s)
#define XSTRINGIFY(s) #s

#define QTEC_LIB_VERSION_MAJOR 1
#define QTEC_LIB_VERSION_MINOR 1
#define QTEC_LIB_VERSION_MICRO 0

#define STRINGYFY_QTEC_LIB_VERSION(major, minor, micro) \
				STR(major) "." STR(minor) "." STR(micro)

#define QTEC_LIB_VERSION_STR STRINGYFY_QTEC_LIB_VERSION( \
	QTEC_LIB_VERSION_MAJOR, QTEC_LIB_VERSION_MINOR, QTEC_LIB_VERSION_MICRO)

#define	QTEC_LIB_CHECK_VERSION(major, minor, micro) \
	(QTEC_LIB_VERSION_MAJOR > (major) || \
	(QTEC_LIB_VERSION_MAJOR == (major) && QTEC_LIB_VERSION_MINOR > (minor)) || \
	(QTEC_LIB_VERSION_MAJOR == (major) && QTEC_LIB_VERSION_MINOR == (minor) && \
	QTEC_LIB_VERSION_MICRO >= (micro)))

G_END_DECLS

#endif /* __QTEC_LIB_CORE_VERSION_H__ */
