/*
 * @Author: Dimitrios Katsaros
 * @Date:   2017-11-23
 */

#ifndef __QTEC_LIB_IO_PAM_INFO_H__
#define __QTEC_LIB_IO_PAM_INFO_H__

/* info functions for pam */
#include <glib.h>

G_BEGIN_DECLS
typedef enum {
	QTEC_IO_PAM_TYPE_BITMAP = 0,
	QTEC_IO_PAM_TYPE_GRAYMAP,
	QTEC_IO_PAM_TYPE_PIXMAP,
	QTEC_IO_PAM_TYPE_ANYMAP,
	QTEC_IO_PAM_TYPE_NO,
} QtecIOPamType;

typedef enum {
	QTEC_IO_PAM_ENC_ASCII,
	QTEC_IO_PAM_ENC_BINARY,
	QTEC_IO_PAM_ENC_NO,
} QtecIOPamEncoding;

const gchar *qtec_io_pam_type_to_string(QtecIOPamType t);
const gchar *qtec_io_pam_encoding_to_string(QtecIOPamEncoding e);
guint qtec_io_pam_type_to_number(QtecIOPamType type, QtecIOPamEncoding enc);
G_END_DECLS

#endif
