/*
* @Author: Marianna S. Buschle <msb@qtec.com>
* @Date:   2017-10-12 15:42
*/

#ifndef __QTEC_LIB_LUT_CORE_H__
#define __QTEC_LIB_LUT_CORE_H__

#include <qtec/v4l2/core.h>

G_BEGIN_DECLS

typedef struct _QtecLutTable QtecLutTable;

typedef enum {
	QTEC_LUT_CHANNEL_MONO,
	QTEC_LUT_CHANNEL_RED,
	QTEC_LUT_CHANNEL_GREEN,
	QTEC_LUT_CHANNEL_BLUE,

	QTEC_LUT_CHANNEL_LAST,
	QTEC_LUT_CHANNEL_INVALID = -1
} QtecLutChannel;

gboolean qtec_lut_new(QtecV4l2Dev *dev, QtecLutChannel channel,
		      QtecLutTable **rettbl, GError **error);
void qtec_lut_free(QtecLutTable *table);

gboolean qtec_lut_get(QtecLutTable *lut, GError **error);
gboolean qtec_lut_set(QtecLutTable *lut, GError **error);

gint qtec_lut_get_max_value(QtecLutTable *lut);
gint qtec_lut_value_percent_to_raw(QtecLutTable *lut, gdouble value_percent);
gint qtec_lut_get_nr_elems(QtecLutTable *lut);
QtecLutChannel qtec_lut_get_lut_channel(QtecLutTable *lut);

gint32 qtec_lut_get_value(QtecLutTable *lut, guint pos, GError **error);
gboolean qtec_lut_set_value(QtecLutTable *lut, guint pos, gint32 val,
			    GError **error);

G_END_DECLS
#endif
