/*
* @Author: Dimitrios Katsaros
* @Date:   2017-05-04 11:43:45
*/

#ifndef __QTEC_LIB_LUT_SET_FUNCTIONS_H__
#define __QTEC_LIB_LUT_SET_FUNCTIONS_H__

#include <qtec/v4l2/core.h>

G_BEGIN_DECLS

gboolean qtec_lut_set_identity(QtecV4l2Dev *dev, gint channel, GError **error);
gboolean qtec_lut_set_threshold(QtecV4l2Dev *dev, gint channel,
				gdouble value_percent, QtecLutThreshold type,
				gboolean reset, GError **error);
gboolean qtec_lut_set_range(QtecV4l2Dev *dev, gint channel,
			    gdouble value_percent_low,
			    gdouble value_percent_high, gboolean reset,
			    GError **error);
gboolean qtec_lut_set_invert(QtecV4l2Dev *dev, gint channel, gboolean reset,
			     GError **error);
gboolean qtec_lut_set_gamma(QtecV4l2Dev *dev, gint channel, gdouble gamma,
			    gboolean reset, GError **error);
gboolean qtec_lut_set_quantization(QtecV4l2Dev *dev, gint channel,
				   gint nr_steps, gboolean reset,
				   GError **error);
gboolean qtec_lut_set_intensity_stretch(QtecV4l2Dev *dev, gint channel,
					gdouble min_intensity_percent,
					gdouble max_intensity_percent,
					gboolean reset, GError **error);
gboolean qtec_lut_set_contrast_mask(QtecV4l2Dev *dev, gint channel,
				    gboolean reset, GError **error);
gboolean qtec_lut_set_Scurve(QtecV4l2Dev *dev, gint channel, gdouble mid_point,
			     gdouble force, gboolean reset, GError **error);
gboolean qtec_lut_set_linear(QtecV4l2Dev *dev, gint channel, gdouble angle,
			     gdouble y0, gboolean reset, GError **error);
gboolean qtec_lut_set_piecewise_linear(QtecV4l2Dev *dev, gint channel,
				       gdouble x1, gdouble y1, gdouble x2,
				       gdouble y2, gboolean reset,
				       GError **error);
gboolean qtec_lut_set_histogram_equalize(QtecV4l2Dev *dev, gint channel,
					 QtecArray *array, gboolean use_sqrt,
					 gboolean reset, GError **error);

G_END_DECLS
#endif
