/*
 * @Author: Dimitrios Katsaros
 * @Date:   2017-10-18
 */

/*
 * Command line option group for core
 */

#ifndef __QTEC_LIB_V4L2_CMD_LINE_H__
#define __QTEC_LIB_V4L2_CMD_LINE_H__

#include <glib.h>
#include <qtec/v4l2/v4l2.h>

G_BEGIN_DECLS
typedef struct _QtecV4l2Options QtecV4l2Options;

/* getters return a reference that needs to be handled, e.g.
 * you need to free the v4l2 device
 */
GOptionGroup *qtec_v4l2_get_option_group(QtecV4l2Options *opts);
QtecV4l2Dev *qtec_v4l2_get_dev(QtecV4l2Options *opts);

/* new and free functions */
void qtec_v4l2_free_v4l2_options(QtecV4l2Options *opts);
QtecV4l2Options *qtec_v4l2_new_v4l2_options();

G_END_DECLS
#endif
