/*
* @Author: Dimitrios Katsaros
* @Date:   2017-05-04 11:43:45
*/

#ifndef __QTEC_LIB_V4L2_EVENT_LOOP_H__
#define __QTEC_LIB_V4L2_EVENT_LOOP_H__

#include <qtec/v4l2/core.h>
#include <glib-object.h>
#include <linux/videodev2_qtec.h>

G_BEGIN_DECLS
/* callback function definitions. Mostly useful as reference */
typedef void (*QtecV4l2FlagsChanged)(QtecV4l2Dev *dev,
				     struct v4l2_query_ext_ctrl *qry,
				     gpointer ptr);
typedef void (*QtecV4l2RangeChanged)(QtecV4l2Dev *dev,
				     struct v4l2_query_ext_ctrl *qry,
				     gpointer ptr);
typedef void (*QtecV4l2ValueChanged)(QtecV4l2Dev *dev,
				     struct v4l2_query_ext_ctrl *qry,
				     GValue *val, gpointer ptr);

/* event loop functions. The loop runs on the default GMainLoop context */
void qtec_v4l2_event_loop_cleanup(QtecV4l2Dev *dev);
void qtec_v4l2_event_loop_create(QtecV4l2Dev *dev);

gboolean qtec_v4l2_emit_value_changed_signal(QtecV4l2Dev *dev,
					     struct v4l2_query_ext_ctrl *qctrl,
					     GValue *val);

G_END_DECLS
#endif
