/*
* @Author: Dimitrios Katsaros
* @Date:   2017-05-04 11:43:45
*/

/*
 * Integration functions from v4l2 to GLib and vice versa
 */

#ifndef __QTEC_LIB_V4L2_GTYPE_H__
#define __QTEC_LIB_V4L2_GTYPE_H__

#include <glib-object.h>
#include <linux/videodev2_qtec.h>
#include <qtec/v4l2/core.h>

G_BEGIN_DECLS
/* v4l2 to gtype and gtype to v4l2 functions */
GType qtec_v4l2_v4l2_to_g_type(struct v4l2_query_ext_ctrl *qctrl);

/* transfers a v4l2_ext_control value to a GValue. Set steal_payload to true
 * if you want the memory pointed by extctrl to be transfered to GValue. Otherwise,
 * the memory is copied
 */
gboolean qtec_v4l2_set_gvalue_from_v4l2extctrl(QtecV4l2Dev *dev, GValue *val,
					       struct v4l2_ext_control *extctrl,
					       gboolean steal_payload);
gboolean qtec_v4l2_set_v4l2extctrl_from_gvalue(QtecV4l2Dev *dev,
					       struct v4l2_ext_control *extctrl,
					       GValue *val);

gboolean qtec_v4l2_get_ctrl_to_gvalue(QtecV4l2Dev *dev, int control_id,
				      GValue *val);
gboolean qtec_v4l2_set_ctrl_from_gvalue(QtecV4l2Dev *dev, int control_id,
					GValue *val);
/* this also updates the gvalue to the new value set by the device */
gboolean qtec_v4l2_set_ctrl_from_gvalue_and_update(QtecV4l2Dev *dev,
						   int control_id, GValue *val);

G_END_DECLS
#endif
