/*
* @Author: Dimitrios Katsaros
* @Date:   2017-05-04 11:43:45
*/

#ifndef __QTEC_LIB_V4L2_SERDES_H__
#define __QTEC_LIB_V4L2_SERDES_H__

#include <glib.h>
#include <linux/videodev2_qtec.h>

G_BEGIN_DECLS
const gchar *qtec_v4l2_serdes_v4l2_type_to_string(__u32 v4l2type);

gboolean qtec_v4l2_serdes_fcc_str_to_v4l2_pixelformat(char *s, __u32 *pixfmt);

/* The following functions create a newely allocated string with the target vaules.
 * Thus, you need to g_free the strings after use
 */

gchar *qtec_v4l2_serdes_v4l2_pixelformat_to_string(__u32 v4l2_pixelformat);

gchar *qtec_v4l2_serdes_v4l2_format_to_string(struct v4l2_format *fmt);

gchar *qtec_v4l2_serdes_serialize_query(struct v4l2_query_ext_ctrl *qctrl,
					gboolean align_text);
gchar *qtec_v4l2_serdes_serialize_query_menu(struct v4l2_querymenu *qmenu,
					     gboolean is_str);
gchar *qtec_v4l2_serdes_serialize_ext_ctrl(struct v4l2_query_ext_ctrl *qctrl,
					   struct v4l2_ext_control *ctrl);
gchar *qtec_v4l2_serdes_serialize_event(struct v4l2_event *event);
/* end of allocated string functions */

gboolean
qtec_v4l2_serdes_deserialize_ext_ctrl(gchar *str,
				      struct v4l2_query_ext_ctrl *qctrl,
				      struct v4l2_ext_control *ctrl);

G_END_DECLS
#endif
