/*
 * @Author: Dimitrios Katsaros
 * @Date:   2017-10-18 11:23:26
 */

#ifndef __QTEC_LIB_V4L2_VALUE_H__
#define __QTEC_LIB_V4L2_VALUE_H__

#include <glib-object.h>
#include <linux/videodev2_qtec.h>

G_BEGIN_DECLS

#define QTEC_V4L2_VALUE_QUERY (qtec_v4l2_value_query_get_type())
#define QTEC_V4L2_VALUE_MENU (qtec_v4l2_value_menu_get_type())
#define QTEC_V4L2_VALUE_EXT_CTRL (qtec_v4l2_value_ext_ctrl_get_type())

GType qtec_v4l2_value_query_get_type(void);
GType qtec_v4l2_value_menu_get_type(void);
GType qtec_v4l2_value_ext_ctrl_get_type(void);

/* query_ext_ctrl */
const struct v4l2_query_ext_ctrl *
qtec_v4l2_value_get_query(const GValue *value);
void qtec_v4l2_value_set_query(GValue *value,
			       const struct v4l2_query_ext_ctrl *qry);
/* check if the query type is of MENU or INT_MENU */
gboolean qtec_v4l2_value_query_is_menu(const GValue *value);

/* v4l2_querymenu */
const struct v4l2_querymenu *qtec_v4l2_value_get_menu(const GValue *value);
void qtec_v4l2_value_set_menu(GValue *value, const struct v4l2_querymenu *menu,
			      guint32 type);
gboolean qtec_v4l2_value_is_menu(const GValue *value);
gboolean qtec_v4l2_value_is_int_menu(const GValue *value);

/* v4l2_ext_ctrl */
void qtec_v4l2_value_set_ext_ctrl(GValue *value, const GValue *extval,
				  const struct v4l2_query_ext_ctrl *qry);
guint qtec_v4l2_value_ext_ctrl_get_id(const GValue *value);
const gchar *qtec_v4l2_value_ext_ctrl_get_name(const GValue *value);
guint qtec_v4l2_value_ext_ctrl_get_ctrl_type(const GValue *value);
void qtec_v4l2_value_ext_ctrl_get_value(const GValue *value, GValue *destval);

G_END_DECLS
#endif
