/*
 * @Author: Marianna S Buschle
 * @Date:   2018-06-25
 */

#ifndef __QTEC_LIB_XFORM_DIST_MAP_H__
#define __QTEC_LIB_XFORM_DIST_MAP_H__

#include <qtec/core/array.h>
#include <linux/qtec/qtec_video.h>

G_BEGIN_DECLS

typedef struct _QtecXFormDistMap QtecXFormDistMap;

gboolean qtec_xform_dist_map_validate_array(QtecArray *arr);

gboolean validate_dist_map_geometry(QtecXFormDistMap *map, guint *width_out,
				    guint *height_out);

QtecXFormDistMap *qtec_xform_dist_map_new(guint width, guint height);
QtecXFormDistMap *qtec_xform_dist_map_new_from_array(QtecArray *arr);
void qtec_xform_dist_map_free(QtecXFormDistMap *map);

QtecArray *qtec_xform_dist_map_get_array_ref(QtecXFormDistMap *map);

gboolean qtec_xform_dist_map_get_dimensions(QtecXFormDistMap *map, guint *width,
					    guint *height);

gboolean qtec_xform_dist_map_set_identity(QtecXFormDistMap *map);

/* helper accessor functions */
gboolean qtec_xform_dist_to_doubles(struct qtec_distortion *ptr, gdouble *xval,
				    gdouble *yval);
gboolean qtec_xform_dist_from_doubles(struct qtec_distortion *ptr, gdouble xval,
				      gdouble yval);
gboolean qtec_xform_get_dist_to_doubles(QtecXFormDistMap *map, gint xpos,
					gint ypos, gdouble *xval,
					gdouble *yval);
gboolean qtec_xform_set_dist_from_doubles(QtecXFormDistMap *map, gint xpos,
					  gint ypos, gdouble xval,
					  gdouble yval);

gboolean qtec_xform_dist_map_is_magic_value(QtecXFormDistMap *map, guint x,
					    guint y);
gboolean qtec_xform_dist_map_is_skip_line(QtecXFormDistMap *map, guint x,
					  guint y);
gboolean qtec_xform_dist_map_is_skip_col(QtecXFormDistMap *map, guint x,
					 guint y);

G_END_DECLS
#endif
