/*
 * @Author: Marianna S Buschle
 * @Date:   2018-06-25
 */

#ifndef __QTEC_LIB_XFORM_GAIN_MAP_H__
#define __QTEC_LIB_XFORM_GAIN_MAP_H__

#include <qtec/core/array.h>

G_BEGIN_DECLS

typedef struct _QtecXFormGainMap QtecXFormGainMap;

gboolean qtec_xform_gain_map_validate_array(QtecArray *arr);

QtecXFormGainMap *qtec_xform_gain_map_new(guint width, guint height);
QtecXFormGainMap *qtec_xform_gain_map_new_from_array(QtecArray *arr);
void qtec_xform_gain_map_free(QtecXFormGainMap *map);

QtecArray *qtec_xform_gain_map_get_array_ref(QtecXFormGainMap *map);

gboolean qtec_xform_gain_map_get_dimensions(QtecXFormGainMap *map, guint *width,
					    guint *height);

gboolean qtec_xform_gain_map_set_identity(QtecXFormGainMap *map);

guint8 *qtec_xform_gain_map_get_val_ptr(QtecXFormGainMap *map, guint x,
					guint y);

G_END_DECLS
#endif
