/*
 * @Author: Marianna S. Buschle
 * @Date:   2018-05-25
 */

#ifndef __QTEC_LIB_XFORM_HOMOGRAPHY_H__
#define __QTEC_LIB_XFORM_HOMOGRAPHY_H__

#include <qtec/core/array.h>
#include <qtec/geometry/core.h>

/* Homography specific operations */

G_BEGIN_DECLS

typedef struct {
	gdouble data[3][3];
} QtecXformHomography;

#define IDENTITY_HOMOGRAPHY \
	((QtecXformHomography){ { { 1, 0, 0 }, { 0, 1, 0 }, { 0, 0, 1 } } })

gboolean qtec_xform_homography_apply(QtecXFormDistMap *map,
				     QtecXformHomography *H, gboolean invert);
QtecXformHomography qtec_xform_calc_perspective(QtecGeometryQuad2d src_points,
						QtecGeometryQuad2d dst_points);

G_END_DECLS
#endif
